Index: boot/arch/sparc64/src/ofw.c
===================================================================
--- boot/arch/sparc64/src/ofw.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/sparc64/src/ofw.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,6 @@
 #include <arch/ofw.h>
 #include <genarch/ofw.h>
-#include <typedefs.h>
+#include <stddef.h>
+#include <stdint.h>
 #include <printf.h>
 #include <halt.h>
Index: boot/genarch/include/ofw.h
===================================================================
--- boot/genarch/include/ofw.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/genarch/include/ofw.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_OFW_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <stdarg.h>
 
Index: boot/genarch/include/ofw_tree.h
===================================================================
--- boot/genarch/include/ofw_tree.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/genarch/include/ofw_tree.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_OFW_TREE_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <genarch/ofw.h>
 
Index: boot/genarch/src/efi.c
===================================================================
--- boot/genarch/src/efi.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/genarch/src/efi.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -29,5 +29,5 @@
 #include <genarch/efi.h>
 #include <arch/types.h>
-#include <typedefs.h>
+#include <stddef.h>
 
 void *efi_vendor_table_find(efi_system_table_t *st, efi_guid_t guid)
Index: boot/genarch/src/multiplication.c
===================================================================
--- boot/genarch/src/multiplication.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/genarch/src/multiplication.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,5 @@
 
 #include <genarch/multiplication.h>
-#include <typedefs.h>
+#include <stdint.h>
 
 /** Set 1 to return INT64_MAX or INT64_MIN on overflow */
Index: boot/genarch/src/ofw.c
===================================================================
--- boot/genarch/src/ofw.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/genarch/src/ofw.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,5 +31,5 @@
 #include <genarch/ofw.h>
 #include <printf.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <str.h>
 #include <align.h>
Index: boot/genarch/src/ofw_tree.c
===================================================================
--- boot/genarch/src/ofw_tree.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/genarch/src/ofw_tree.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #include <genarch/ofw.h>
 #include <arch/ofw.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <str.h>
 #include <balloc.h>
Index: boot/generic/include/balloc.h
===================================================================
--- boot/generic/include/balloc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/balloc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_BALLOC_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 
 typedef struct {
Index: boot/generic/include/errno.h
===================================================================
--- boot/generic/include/errno.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/errno.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,5 +31,5 @@
 
 #ifndef BOOT_ERRNO_H_
-#define BOTT_ERRNO_H_
+#define BOOT_ERRNO_H_
 
 #define EOK        0    /* No error. */
Index: boot/generic/include/inflate.h
===================================================================
--- boot/generic/include/inflate.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/inflate.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
 #define BOOT_INFLATE_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 
 extern int inflate(void *, size_t, void *, size_t);
Index: boot/generic/include/memstr.h
===================================================================
--- boot/generic/include/memstr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/memstr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,5 @@
 #define BOOT_MEMSTR_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 
 extern void *memcpy(void *, const void *, size_t)
Index: boot/generic/include/printf.h
===================================================================
--- boot/generic/include/printf.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/printf.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,5 @@
 #define BOOT_PRINT_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <stdarg.h>
 #include <printf_verify.h>
Index: boot/generic/include/printf_core.h
===================================================================
--- boot/generic/include/printf_core.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/printf_core.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,5 @@
 #define BOOT_PRINTF_CORE_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <stdarg.h>
 
Index: boot/generic/include/putchar.h
===================================================================
--- boot/generic/include/putchar.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/putchar.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define BOOT_PUTCHAR_H_
 
+#include <stddef.h>
+
 extern void putchar(const wchar_t);
 
Index: boot/generic/include/stdbool.h
===================================================================
--- boot/generic/include/stdbool.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ boot/generic/include/stdbool.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file
+ */
+
+#ifndef BOOT_STDBOOL_H_
+#define BOOT_STDBOOL_H_
+
+#define false  0
+#define true   1
+
+#define bool _Bool
+
+#endif
+
+/** @}
+ */
Index: boot/generic/include/stddef.h
===================================================================
--- boot/generic/include/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ boot/generic/include/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file
+ */
+
+#ifndef BOOT_STDDEF_H_
+#define BOOT_STDDEF_H_
+
+#include <arch/common.h>
+#include <arch/types.h>
+
+#define NULL  ((void *) 0)
+
+#endif
+
+/** @}
+ */
Index: boot/generic/include/stdint.h
===================================================================
--- boot/generic/include/stdint.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/stdint.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,4 +33,7 @@
 #define BOOT_STDINT_H_
 
+#include <arch/common.h>
+#include <arch/types.h>
+
 #define INT8_MIN  INT8_C(0x80)
 #define INT8_MAX  INT8_C(0x7F)
Index: boot/generic/include/str.h
===================================================================
--- boot/generic/include/str.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/include/str.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,6 @@
 #define BOOT_STR_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
 
 /**< Common Unicode characters */
Index: boot/generic/src/balloc.c
===================================================================
--- boot/generic/src/balloc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/src/balloc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,5 +28,5 @@
 
 #include <balloc.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <align.h>
 
Index: boot/generic/src/inflate.c
===================================================================
--- boot/generic/src/inflate.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/src/inflate.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -65,5 +65,6 @@
  */
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
 #include <errno.h>
 #include <memstr.h>
Index: boot/generic/src/memstr.c
===================================================================
--- boot/generic/src/memstr.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/src/memstr.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,5 +28,5 @@
 
 #include <memstr.h>
-#include <typedefs.h>
+#include <stddef.h>
 
 /** Move memory block without overlapping.
Index: boot/generic/src/printf_core.c
===================================================================
--- boot/generic/src/printf_core.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/src/printf_core.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,6 @@
 #include <printf.h>
 #include <stdarg.h>
+#include <stdbool.h>
+#include <stddef.h>
 #include <macros.h>
 #include <str.h>
Index: boot/generic/src/str.c
===================================================================
--- boot/generic/src/str.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/src/str.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -98,6 +98,8 @@
  */
 
+#include <errno.h>
+#include <stdbool.h>
+#include <stddef.h>
 #include <str.h>
-#include <errno.h>
 
 /** Check the condition if wchar_t is signed */
Index: boot/generic/src/vprintf.c
===================================================================
--- boot/generic/src/vprintf.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/generic/src/vprintf.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,5 +30,5 @@
  */
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <printf.h>
 #include <printf_core.h>
Index: contrib/qemu/build-from-scratch.sh
===================================================================
--- contrib/qemu/build-from-scratch.sh	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ contrib/qemu/build-from-scratch.sh	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -29,5 +29,5 @@
 #
 
-VERSION=2.9.0
+VERSION=2.10.0
 BASENAME=qemu-${VERSION}
 BASENAME_MASTER=qemu-master
@@ -36,5 +36,5 @@
 URL=http://wiki.qemu-project.org/download/${TARBALL}
 REPO=git://git.qemu.org/qemu.git
-MD5="02781eb15b364aedef79da7a5113f5b7"
+MD5="ca73441de73a9b52c6c49c97190d2185"
 
 OPENSPARC_TARBALL="OpenSPARCT1_Arch.1.5.tar.bz2"
Index: contrib/tools/random_check.sh
===================================================================
--- contrib/tools/random_check.sh	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ contrib/tools/random_check.sh	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,5 +52,4 @@
 		echo "COMPILER=gcc_native" >>"$PRUNE_CONFIG_FILE"
 		echo "COMPILER=gcc_helenos" >>"$PRUNE_CONFIG_FILE"
-		echo "COMPILER=icc" >>"$PRUNE_CONFIG_FILE"
 		;;
 	*|h)
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -82,45 +82,29 @@
 INCLUDES_FLAGS = $(addprefix -I,$(INCLUDES))
 
-ifeq ($(CONFIG_OPTIMIZE_FOR_SIZE),y)
-	OPTIMIZATION = s
-else
-	OPTIMIZATION = 3
-endif
-
 DEFS = -DKERNEL -DRELEASE=$(RELEASE) "-DCOPYRIGHT=$(COPYRIGHT)" "-DNAME=$(NAME)" -D__$(BITS)_BITS__ -D__$(ENDIANESS)__
 
-GCC_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
-	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-std=gnu99 -Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-pipe
-
-ICC_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-ffreestanding -fno-builtin -nostdlib -nostdinc -Wall -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -wd170
-
-# clang does not support following options but I am not sure whether
-# something won't break because of that:
-# -fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) -finput-charset=UTF-8
-CLANG_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
+COMMON_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
 	-ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-std=gnu99 -Wall -Werror -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-integrated-as -pipe -target $(CLANG_TARGET)
+	-fexec-charset=UTF-8 -finput-charset=UTF-8
+
+GCC_CFLAGS = -std=gnu99 -Wall -Wextra -Wno-unused-parameter \
+	-Wmissing-prototypes -Werror-implicit-function-declaration \
+	-Wwrite-strings -pipe
+
+CLANG_CFLAGS = -std=gnu99 -Wall -Wextra -Wno-unused-parameter \
+	-Wno-missing-field-initializers -Wno-unused-command-line-argument \
+	-Wmissing-prototypes -Werror-implicit-function-declaration \
+	-Wwrite-strings -pipe -fno-stack-protector -fno-PIC
 
 ifeq ($(CONFIG_DEBUG),y)
-	GCC_CFLAGS += -Werror
-	ICC_CFLAGS += -Werror
+	COMMON_CFLAGS += -Werror
 endif
 
 ifeq ($(CONFIG_LTO),y)
-	GCC_CFLAGS += -flto
+	COMMON_CFLAGS += -flto
 endif
 
 ifeq ($(CONFIG_LINE_DEBUG),y)
-	GCC_CFLAGS += -g
-	ICC_CFLAGS += -g
-	CLANG_CFLAGS += -g
+	COMMON_CFLAGS += -g
 endif
 
@@ -129,6 +113,13 @@
 # AFLAGS and LFLAGS must be initialized before the inclusion.
 #
-AFLAGS = --fatal-warnings
+AFLAGS =
 LFLAGS = -n -T $(LINK) -M --fatal-warnings
+
+# FIXME: This condition is a workaround for issues #693 and #694.
+ifneq ($(KARCH),sparc64)
+ifneq ($(KARCH),mips32)
+	AFLAGS += --fatal-warnings
+endif
+endif
 
 #
@@ -162,5 +153,5 @@
 
 ifeq ($(COMPILER),gcc_native)
-	CFLAGS = $(GCC_CFLAGS)
+	CFLAGS = $(COMMON_CFLAGS) $(GCC_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 	INSTRUMENTATION = -finstrument-functions
@@ -168,5 +159,5 @@
 
 ifeq ($(COMPILER),gcc_cross)
-	CFLAGS = $(GCC_CFLAGS)
+	CFLAGS = $(COMMON_CFLAGS) $(GCC_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 	INSTRUMENTATION = -finstrument-functions
@@ -174,19 +165,13 @@
 
 ifeq ($(COMPILER),gcc_helenos)
-	CFLAGS = $(GCC_CFLAGS)
+	CFLAGS = $(COMMON_CFLAGS) $(GCC_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 	INSTRUMENTATION = -finstrument-functions
 endif
 
-ifeq ($(COMPILER),icc)
-	CFLAGS = $(ICC_CFLAGS)
+ifeq ($(COMPILER),clang)
+	CFLAGS = $(COMMON_CFLAGS) $(CLANG_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-	INSTRUMENTATION =
-endif
-
-ifeq ($(COMPILER),clang)
-	CFLAGS = $(CLANG_CFLAGS)
-	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-	INSTRUMENTATION =
+	INSTRUMENTATION = -finstrument-functions
 endif
 
@@ -209,5 +194,4 @@
 	generic/src/ddi/ddi.c \
 	generic/src/ddi/irq.c \
-	generic/src/ddi/device.c \
 	generic/src/debug/symtab.c \
 	generic/src/debug/stacktrace.c \
@@ -240,7 +224,7 @@
 	generic/src/mm/slab.c \
 	generic/src/lib/func.c \
-	generic/src/lib/memstr.c \
+	generic/src/lib/mem.c \
 	generic/src/lib/memfnc.c \
-	generic/src/lib/sort.c \
+	generic/src/lib/gsort.c \
 	generic/src/lib/str.c \
 	generic/src/lib/elf.c \
@@ -272,8 +256,6 @@
 	generic/src/ipc/sysipc.c \
 	generic/src/ipc/sysipc_ops.c \
-	generic/src/ipc/ops/clnestab.c \
 	generic/src/ipc/ops/conctmeto.c \
 	generic/src/ipc/ops/concttome.c \
-	generic/src/ipc/ops/connclone.c \
 	generic/src/ipc/ops/dataread.c \
 	generic/src/ipc/ops/datawrite.c \
@@ -286,5 +268,6 @@
 	generic/src/ipc/irq.c \
 	generic/src/ipc/event.c \
-	generic/src/security/cap.c \
+	generic/src/cap/cap.c \
+	generic/src/security/perm.c \
 	generic/src/sysinfo/sysinfo.c \
 	generic/src/sysinfo/stats.c
@@ -392,5 +375,10 @@
 AUTOGENS_AG := $(ARCH_AUTOGENS_AG) $(GENARCH_AUTOGENS_AG)
 
-LFLAGS_LTO := $(addprefix -Xlinker ,$(LFLAGS))
+AS_CFLAGS := $(addprefix -Xassembler ,$(AFLAGS))
+LD_CFLAGS := $(addprefix -Xlinker ,$(LFLAGS))
+
+ifeq ($(COMPILER),clang)
+	AS_CFLAGS += -mllvm -asm-macro-max-nesting-depth=1000
+endif
 
 ifeq ($(CONFIG_SYMTAB),y)
@@ -412,5 +400,5 @@
 $(RAW): $(LINK) $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(SYMTAB_OBJECTS)
 ifeq ($(CONFIG_LTO),y)
-	$(GCC) $(LFLAGS_LTO) -Xlinker -Map -Xlinker $(MAP) $(DEFS) $(GCC_CFLAGS) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SYMTAB_OBJECTS)
+	$(CC) $(DEFS) $(CFLAGS) $(LD_CFLAGS) -Xlinker -Map -Xlinker $(MAP) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SYMTAB_OBJECTS)
 else
 	$(LD) $(LFLAGS) -Map $(MAP) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SYMTAB_OBJECTS)
@@ -425,15 +413,15 @@
 %.h: %.ag
 	$(AUTOGEN) probe $< >$<.probe.c
-	$(CC) $(DEFS) $(CFLAGS) -S -o $<.probe.s $<.probe.c
+	$(CC_AUTOGEN) $(DEFS) $(CFLAGS) -S -o $<.probe.s $<.probe.c
 	$(AUTOGEN) generate $< <$<.probe.s >$@   
 
 %.o: %.S $(DEPEND)
-	$(GCC) $(DEFS) $(GCC_CFLAGS) -D__ASM__ -c -o $@ $<
+	$(CC) $(DEFS) $(CFLAGS) $(AS_CFLAGS) -D__ASM__ -c -o $@ $<
 ifeq ($(PRECHECK),y)
-	$(JOBFILE) $(JOB) $< $@ as asm/preproc $(DEFS) $(GCC_CFLAGS) -D__ASM__
+	$(JOBFILE) $(JOB) $< $@ as asm/preproc $(DEFS) $(CFLAGS) -D__ASM__
 endif
 
 %.o: %.s $(DEPEND)
-	$(AS) $(AFLAGS) -o $@ $<
+	$(CC) $(DEFS) $(CFLAGS) $(AS_CFLAGS) -D__ASM__ -c -o $@ $<
 ifeq ($(PRECHECK),y)
 	$(JOBFILE) $(JOB) $< $@ as asm $(DEFS) $(CFLAGS) $(EXTRA_FLAGS)
@@ -447,10 +435,10 @@
 
 $(REAL_MAP).o: $(REAL_MAP).bin
-	echo "$(AS_PROLOG)""$(SYMTAB_SECTION)"" .incbin \"$<\"" | $(AS) $(AFLAGS) -o $@
+	echo "$(AS_PROLOG)""$(SYMTAB_SECTION)"" .incbin \"$<\"" | $(CC) $(CFLAGS) $(AS_CFLAGS) -x assembler -c -o $@ -
 
 $(REAL_MAP).bin: $(LINK) $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS)
-	echo "$(AS_PROLOG)""$(SYMTAB_SECTION)" | $(AS) $(AFLAGS) -o $(EMPTY_MAP)
+	echo "$(AS_PROLOG)""$(SYMTAB_SECTION)" | $(CC) $(CFLAGS) $(AS_CFLAGS) -x assembler -c -o $(EMPTY_MAP) -
 ifeq ($(CONFIG_LTO),y)
-	$(GCC) $(LFLAGS_LTO) -Xlinker -Map -Xlinker $(MAP_PREV) $(DEFS) $(GCC_CFLAGS) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(EMPTY_MAP)
+	$(CC) $(DEFS) $(CFLAGS) $(LD_CFLAGS) -Xlinker -Map -Xlinker $(MAP_PREV) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(EMPTY_MAP)
 else
 	$(LD) $(LFLAGS) -Map $(MAP_PREV) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(EMPTY_MAP)
@@ -462,7 +450,7 @@
 	# on architectures that have bss after symtab
 	
-	echo "$(AS_PROLOG)""$(SYMTAB_SECTION)"" .incbin \"$@\"" | $(AS) $(AFLAGS) -o $(SIZEOK_MAP)
+	echo "$(AS_PROLOG)""$(SYMTAB_SECTION)"" .incbin \"$@\"" | $(CC) $(CFLAGS) $(AS_CFLAGS) -x assembler -c -o $(SIZEOK_MAP) -
 ifeq ($(CONFIG_LTO),y)
-	$(GCC) $(LFLAGS_LTO) -Xlinker -Map -Xlinker $(MAP_PREV) $(DEFS) $(GCC_CFLAGS) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SIZEOK_MAP)
+	$(CC) $(DEFS) $(CFLAGS) $(LD_CFLAGS) -Xlinker -Map -Xlinker $(MAP_PREV) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SIZEOK_MAP)
 else
 	$(LD) $(LFLAGS) -Map $(MAP_PREV) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SIZEOK_MAP)
Index: kernel/arch/abs32le/Makefile.inc
===================================================================
--- kernel/arch/abs32le/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,5 +35,5 @@
 	
 	ifeq ($(CROSS_TARGET),mips32)
-		GCC_CFLAGS += -mno-abicalls
+		COMMON_CFLAGS += -mno-abicalls
 	endif
 endif
Index: kernel/arch/abs32le/include/arch/fpu_context.h
===================================================================
--- kernel/arch/abs32le/include/arch/fpu_context.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/fpu_context.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,4 @@
 #define KERN_abs32le_FPU_CONTEXT_H_
 
-#include <typedefs.h>
-
 #define FPU_CONTEXT_ALIGN  16
 
Index: kernel/arch/abs32le/include/arch/interrupt.h
===================================================================
--- kernel/arch/abs32le/include/arch/interrupt.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/interrupt.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #define KERN_abs32le_INTERRUPT_H_
 
-#include <typedefs.h>
 #include <arch/istate.h>
 
Index: kernel/arch/abs32le/include/arch/istate.h
===================================================================
--- kernel/arch/abs32le/include/arch/istate.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/istate.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,7 +40,10 @@
 #ifdef KERNEL
 
+#include <typedefs.h>
 #include <verify.h>
 
 #else /* KERNEL */
+
+#include <stdint.h>
 
 #define REQUIRES_EXTENT_MUTABLE(arg)
Index: kernel/arch/abs32le/include/arch/mm/asid.h
===================================================================
--- kernel/arch/abs32le/include/arch/mm/asid.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/mm/asid.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 #define KERN_abs32le_ASID_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 typedef uint32_t asid_t;
Index: kernel/arch/abs32le/include/arch/mm/frame.h
===================================================================
--- kernel/arch/abs32le/include/arch/mm/frame.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/mm/frame.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,6 +41,4 @@
 #define FRAME_LOWPRIO  0
 
-#include <typedefs.h>
-
 extern void frame_low_arch_init(void);
 extern void frame_high_arch_init(void);
Index: kernel/arch/abs32le/include/arch/mm/km.h
===================================================================
--- kernel/arch/abs32le/include/arch/mm/km.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/mm/km.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define KERN_abs32le_KM_H_
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/arch/abs32le/include/arch/mm/page.h
===================================================================
--- kernel/arch/abs32le/include/arch/mm/page.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/mm/page.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 
 #include <arch/mm/frame.h>
+#include <stdbool.h>
 #include <trace.h>
 
Index: kernel/arch/abs32le/include/arch/proc/task.h
===================================================================
--- kernel/arch/abs32le/include/arch/proc/task.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/proc/task.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #define KERN_abs32le_TASK_H_
 
-#include <typedefs.h>
 #include <adt/bitmap.h>
 
Index: kernel/arch/abs32le/include/arch/proc/thread.h
===================================================================
--- kernel/arch/abs32le/include/arch/proc/thread.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/proc/thread.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,4 @@
 #define KERN_abs32le_THREAD_H_
 
-#include <typedefs.h>
-
 typedef struct {
 } thread_arch_t;
Index: kernel/arch/abs32le/include/arch/types.h
===================================================================
--- kernel/arch/abs32le/include/arch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/include/arch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define KERN_abs32le_TYPES_H_
 
+#include <arch/common.h>
+
 #define ATOMIC_COUNT_MIN  UINT32_MIN
 #define ATOMIC_COUNT_MAX  UINT32_MAX
@@ -54,7 +56,4 @@
 } fncptr_t;
 
-#define INTN_C(c)   INT32_C(c)
-#define UINTN_C(c)  UINT32_C(c)
-
 #define PRIdn  PRId32  /**< Format for native_t. */
 #define PRIun  PRIu32  /**< Format for sysarg_t. */
Index: kernel/arch/abs32le/src/abs32le.c
===================================================================
--- kernel/arch/abs32le/src/abs32le.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/src/abs32le.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,14 +40,12 @@
 #include <func.h>
 #include <config.h>
+#include <console/console.h>
 #include <errno.h>
 #include <context.h>
 #include <fpu_context.h>
 #include <interrupt.h>
+#include <ddi/irq.h>
 #include <syscall/copy.h>
-#include <ddi/irq.h>
-#include <proc/thread.h>
 #include <syscall/syscall.h>
-#include <console/console.h>
-#include <memstr.h>
 
 static void abs32le_post_mm_init(void);
Index: kernel/arch/abs32le/src/cpu/cpu.c
===================================================================
--- kernel/arch/abs32le/src/cpu/cpu.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/src/cpu/cpu.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #include <cpu.h>
 #include <arch.h>
-#include <typedefs.h>
 #include <print.h>
 #include <fpu_context.h>
@@ -57,5 +56,5 @@
 }
 
-void cpu_print_report(cpu_t* cpu)
+void cpu_print_report(cpu_t *cpu)
 {
 }
Index: kernel/arch/abs32le/src/debug/stacktrace.c
===================================================================
--- kernel/arch/abs32le/src/debug/stacktrace.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/src/debug/stacktrace.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,6 +34,6 @@
 
 #include <stacktrace.h>
+#include <stdbool.h>
 #include <syscall/copy.h>
-#include <typedefs.h>
 
 bool kernel_stack_trace_context_validate(stack_trace_context_t *ctx)
Index: kernel/arch/abs32le/src/mm/page.c
===================================================================
--- kernel/arch/abs32le/src/mm/page.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/src/mm/page.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,4 @@
 #include <mm/page.h>
 #include <mm/as.h>
-#include <typedefs.h>
 #include <align.h>
 #include <config.h>
@@ -46,5 +45,4 @@
 #include <arch/asm.h>
 #include <debug.h>
-#include <memstr.h>
 #include <print.h>
 #include <interrupt.h>
Index: kernel/arch/abs32le/src/userspace.c
===================================================================
--- kernel/arch/abs32le/src/userspace.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/abs32le/src/userspace.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #include <userspace.h>
-#include <typedefs.h>
+#include <stdbool.h>
 #include <arch.h>
 #include <abi/proc/uarg.h>
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -32,8 +32,5 @@
 
 FPU_NO_CFLAGS = -mno-sse -mno-sse2
-CMN1 = -m64 -mcmodel=$(MEMORY_MODEL) -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
-GCC_CFLAGS += $(CMN1)
-ICC_CFLAGS += $(CMN1)
-CLANG_CFLAGS += $(CMN1)
+COMMON_CFLAGS += -m64 -mcmodel=$(MEMORY_MODEL) -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
 
 BITS = 64
@@ -44,7 +41,5 @@
 
 ifeq ($(PROCESSOR),opteron)
-	CMN2 := -march=opteron
-	GCC_CFLAGS += $(CMN2)
-	ICC_CFLAGS += $(CMN2)
+	COMMON_CFLAGS += -march=opteron
 endif
 
Index: kernel/arch/amd64/include/arch/atomic.h
===================================================================
--- kernel/arch/amd64/include/arch/atomic.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/atomic.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,4 @@
 #define KERN_amd64_ATOMIC_H_
 
-#include <typedefs.h>
 #include <arch/barrier.h>
 #include <preemption.h>
Index: kernel/arch/amd64/include/arch/cpuid.h
===================================================================
--- kernel/arch/amd64/include/arch/cpuid.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/cpuid.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,5 +48,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <stdint.h>
 
 typedef struct {
